-- hud stuff

if game ~= GAME_STAR_ROAD then
    levelinfo = {
        [LEVEL_BOB] = {
            desc = 'Bomb-Omb Battlefield',
            author = "Nintendo",
            lvlc = "bob",
            containsbase = true,
            indefaultflood = true
        },
        [LEVEL_WF] = {
            desc = 'Whomp\'s Fortress',
            author = "Nintendo",
            lvlc = "wf",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_CCM] = {
            desc = 'Cool Cool Mountain',
            author = "Nintendo",
            lvlc = "ccm",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_BITDW] = {
            desc = 'Bowser Level 1',
            author = "Nintendo",
            lvlc = "bitdw",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_BBH] = {
            desc = 'Big Boo\'s Haunt',
            author = "Nintendo",
            lvlc = "bbh",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_HMC] = {
            desc = 'Hazy Maze Cave',
            author = "Nintendo",
            lvlc = "hmc",
            containsbase = true,
            indefaultflood = true
        },
        [LEVEL_LLL] = {
            desc = 'Lethal Lava Land (Volcano)',
            author = "Nintendo",
            lvlc = "lll",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_SSL] = {
            desc = 'Shifting Sand Land (Pyramid)',
            author = "Nintendo",
            lvlc = "ssl",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_WDW] = {
            desc = 'Wet Dry World',
            author = "Nintendo",
            lvlc = "wdw",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_TTM] = {
            desc = 'Tall Tall Mountain',
            author = "Nintendo",
            lvlc = "ttm",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_THI] = {
            desc = 'Tiny Huge Island',
            author = "Nintendo",
            lvlc = "thi",
            containsbase = true,
            indefaultflood = true
        },
        [LEVEL_TTC] = {
            desc = 'Tick Tock Clock',
            author = "Nintendo",
            lvlc = "ttc",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_BITS] = {
            desc = 'Bowser Level 3',
            author = "Nintendo",
            lvlc = "bits",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_CTT] = {
            desc = 'Climb the Tower',
            author = "Agent X",
            lvlc = "ctt",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_SL] = {
            desc = 'Underground Platforms',
            author = "Birdekek",
            lvlc = "up",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_RR] = {
            desc = 'Rainbow Ride',
            author = "Nintendo",
            lvlc = "rr",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_JRB] = {
            desc = 'Jolly Roger Bay',
            author = "Nintendo",
            lvlc = "jrb",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_DDD] = {
            desc = 'Dire Dire Docks',
            author = "Nintendo",
            lvlc = "ddd",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_WMOTR] = {
            desc = 'Frozen Cold Slopes',
            author = "Birdekek",
            lvlc = "fcs",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_VCUTM] = {
            desc = 'Vanish Cap under the Moat',
            author = "Nintendo",
            lvlc = "vcutm",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_TOTWC] = {
            desc = 'Tower of the Wing Cap',
            author = "Nintendo",
            lvlc = "totwc",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_COTMC] = {
            desc = 'Cavern of The Metal Cap',
            author = "Nintendo",
            lvlc = "cotmc",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_PSS] = {
            desc = 'The Princesses Secret Slide',
            author = "Nintendo",
            lvlc = "tpss",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_CASTLE_GROUNDS] = {
            desc = 'Castle Grounds',
            author = "Nintendo",
            lvlc = "castle_grounds",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_BITFS] = {
            desc = 'Bowser Level 2',
            author = "Nintendo",
            lvlc = "bitfs",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_CS] = {
            desc = 'Crystal Slide',
            author = "Birdekek",
            lvlc = "cs",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_MC] = {
            desc = 'Mountain Chog',
            author = "Birdekek",
            lvlc = "mc",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_CONSTRUCT] = {
            desc = 'gm_construct',
            author = "Birdekek",
            lvlc = "construct",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_OBBY] = {
            desc = 'Obby',
            author = "Zyaxyl",
            lvlc = "obby",
            containsbase = true,
            indefaultflood = false
        }
    }
else
    levelinfo = {
        [LEVEL_BOB] = {
            desc = 'Bomb-Omb Islands',
            author = "Nintendo",
            lvlc = "bob",
            containsbase = true,
            indefaultflood = true
        },
        [LEVEL_WF] = {
            desc = 'Sky Land Resort',
            author = "Nintendo",
            lvlc = "wf",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_JRB] = {
            desc = 'Piranha Plant Pond',
            author = "Nintendo",
            lvlc = "jrb",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_CCM] = {
            desc = 'Chuckya Harbor',
            author = "Nintendo",
            lvlc = "ccm",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_PSS] = {
            desc = 'Mushroom Mountain Town',
            author = "Nintendo",
            lvlc = "tpss",
            containsbase = true,
            indefaultflood = true
        },
        [LEVEL_BITDW] = {
            desc = 'Bowser Level 1',
            author = "Nintendo",
            lvlc = "bitdw",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_BBH] = {
            desc = 'Gloomy Garden',
            author = "Nintendo",
            lvlc = "bbh",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_LLL] = {
            desc = 'Koopa Canyon',
            author = "Nintendo",
            lvlc = "lll",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_SL] = {
            desc = 'Underground Platforms',
            author = "Birdekek",
            lvlc = "up",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_WDW] = {
            desc = 'Colossal Candy Clutter',
            author = "Nintendo",
            lvlc = "wdw",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_TTM] = {
            desc = 'Cloudrail Station',
            author = "Nintendo",
            lvlc = "ttm",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_TTC] = {
            desc = 'Bomb-Omb Battle Factory',
            author = "Nintendo",
            lvlc = "ttc",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_RR] = {
            desc = 'Rainbow Ride',
            author = "Nintendo",
            lvlc = "rr",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_CASTLE_GROUNDS] = {
            desc = 'Star Leap Tower Grounds',
            author = "Nintendo",
            lvlc = "castle_grounds",
            containsbase = false,
            indefaultflood = true
        },
        [LEVEL_CTT] = {
            desc = 'Climb the Tower Flood',
            author = "Agent X",
            lvlc = "ctt",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_WMOTR] = {
            desc = 'Frozen Cold Slopes',
            author = "Birdekek",
            lvlc = "fcs",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_VCUTM] = {
            desc = 'Puzzle of the Vanish Cap',
            author = "Nintendo",
            lvlc = "vcutm",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_TOTWC] = {
            desc = 'Windy Wing Cap Well',
            author = "Nintendo",
            lvlc = "wing",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_COTMC] = {
            desc = 'Creepy Cap Cave',
            author = "Nintendo",
            lvlc = "metal",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_CS] = {
            desc = 'Crystal Slide',
            author = "Birdekek",
            lvlc = "cs",
            containsbase = false,
            indefaultflood = false
        },
        [LEVEL_MC] = {
            desc = 'Mountain Chog',
            author = "Birdekek",
            lvlc = "mc",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_CONSTRUCT] = {
            desc = 'gm_construct',
            author = "Birdekek",
            lvlc = "construct",
            containsbase = true,
            indefaultflood = false
        },
        [LEVEL_OBBY] = {
            desc = 'Obby',
            author = "Zyaxyl",
            lvlc = "obby",
            containsbase = true,
            indefaultflood = false
        }
    }
end